var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "office-ui-fabric-react/lib/components/GroupedList/index", "office-ui-fabric-react/lib/Link", "@uifabric/example-app-base", "./GroupedList.Custom.Example.scss"], function (require, exports, React, index_1, Link_1, example_app_base_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var _items;
    var _groups;
    var GroupedListCustomExample = (function (_super) {
        __extends(GroupedListCustomExample, _super);
        function GroupedListCustomExample() {
            var _this = _super.call(this) || this;
            _items = _items || example_app_base_1.createListItems(20);
            _groups = example_app_base_1.createGroups(4, 0, 0, 5);
            return _this;
        }
        GroupedListCustomExample.prototype.render = function () {
            return (React.createElement(index_1.GroupedList, { ref: 'groupedList', items: _items, onRenderCell: this._onRenderCell, groupProps: {
                    onRenderHeader: this._onRenderHeader,
                    onRenderFooter: this._onRenderFooter
                }, groups: _groups }));
        };
        GroupedListCustomExample.prototype._onRenderCell = function (nestingDepth, item, itemIndex) {
            return (React.createElement("div", { "data-selection-index": itemIndex },
                React.createElement("span", { className: 'ms-GroupedListExample-name' }, item.name)));
        };
        GroupedListCustomExample.prototype._onRenderHeader = function (props) {
            return (React.createElement("div", { className: 'ms-GroupedListExample-header ms-font-xl' },
                "This is a custom header for ",
                props.group.name,
                "(",
                React.createElement(Link_1.Link, { onClick: function () { return props.onToggleCollapse(props.group); } }, props.group.isCollapsed ? 'Expand' : 'Collapse'),
                ")"));
        };
        GroupedListCustomExample.prototype._onRenderFooter = function (props) {
            return (React.createElement("div", { className: 'ms-GroupedListExample-footer ms-font-xl' },
                "This is a custom footer for ",
                props.group.name));
        };
        return GroupedListCustomExample;
    }(React.Component));
    exports.GroupedListCustomExample = GroupedListCustomExample;
});

//# sourceMappingURL=GroupedList.Custom.Example.js.map
